<app-loading *ngIf="loading"></app-loading>

<ng-template #name>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="fill"></em>
    <span>{{'modelOrganization.validate.requiredFieldToEnter' | translate}}</span>
  </div>
</ng-template>


<ng-template #branch>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="fill"></em>
    <span>{{'modelOrganization.validate.requiredFieldToEnter' | translate}}</span>
  </div>
</ng-template>

<ng-template #valid>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="fill"></em>
    <span>{{'organization.common.validate.wrongDataFormat' | translate}}</span>
  </div>
</ng-template>

<ng-template #require>
  <div class="error">
    <em nz-icon nzType="close-circle" nzTheme="fill"></em>
    <span>
      {{'modelOrganization.validate.requiredValidateWithName'
      | translate: {'param': 'modelOrganization.table.unitNameLowercase' | translate} }}
    </span>
  </div>
</ng-template>


<form [formGroup]="formInput" nz-form>
  <div class="content-header">
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="submit()" *ngIf="objFunction.create"
               mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.saveS' | translate}}">
    </mb-button>
  </div>

  <div class="init-model-template-card">

    <div nz-row>
      <div nz-col nzSpan="6" class="init-model-template-card__left">
        <div>
          <span nz-typography class="init-model-template-card__left__label">
            {{'modelOrganization.table.formName' | translate}}<span
              class="init-model-template-card__left__require">*</span></span>
        </div>
        <nz-form-item>
          <nz-form-control nzValidateStatus="" [nzErrorTip]="formInput.controls.orgName.errors?.pattern ? valid : name">
            <input nz-input formControlName="orgName" class="init-model-template-card__left__input"
              placeholder="{{'modelOrganization.validate.pleaseInputParam' |
              translate: {'param': 'modelOrganization.table.formNameLowercase' | translate} }}" />
          </nz-form-control>
        </nz-form-item>
      </div>

      <div nz-col nzSpan="6" class="init-model-template-card__center">
        <div>
          <span nz-typography class="init-model-template-card__center__label">{{'modelOrganization.table.status' | translate}}</span>
        </div>
        <nz-select class="init-model-template-card__center__select" nzPlaceHolder="Chọn tình trạng" nzAllowClear
          formControlName="flagStatus" [nzDisabled]="!id">
          <nz-option nzValue="1" nzLabel="Sử dụng"></nz-option>
          <nz-option nzValue="0" nzLabel="Không sử dụng"></nz-option>
        </nz-select>
      </div>

      <div nz-col nzSpan="6" class="init-model-template-card__center">
        <div>
          <span nz-typography class="init-model-template-card__center__label">Loại chi nhánh <span
              class="init-model-template-card__left__require"></span></span>
        </div>
        <nz-form-item>
          <nz-form-control nzValidateStatus="" [nzErrorTip]="branch">
            <nz-select class="init-model-template-card__center__select" formControlName="branchType"
              nzPlaceHolder="Chọn loại chi nhánh" nzAllowClear>
              <nz-option *ngFor="let data of listBranch" nzValue="{{data.lvaValue}}" nzLabel="{{data.lvaMean}}">
              </nz-option>
            </nz-select>
          </nz-form-control>
        </nz-form-item>
      </div>

    </div>
  </div>

  <div class="init-model-template-table">
    <nz-table #basicTable [nzData]="listData.length ? listData : []" [nzFrontPagination]="false" [nzSize]="TABLE_SIZE">
      <thead>
        <tr>
          <th scope="col"  [nzWidth]="WIDTH_COLUMN.CHECKED" nzLeft>{{'modelOrganization.table.index' | translate}}</th>
          <th scope="col"  nzWidth="40%">{{'modelOrganization.table.unitName' | translate}}</th>
          <th scope="col" >Job</th>
          <th scope="col"  [nzWidth]="WIDTH_COLUMN.CHECKED"></th>
        </tr>
      </thead>
      <tbody>
        <ng-container *ngFor="let data of listData; let i = index">
          <tr>
            <td nzLeft>{{i+1}}</td>
            <td>
              <nz-form-item>
                <nz-form-control nzValidateStatus="" [nzErrorTip]="data.control.errors?.pattern ? valid : require">
                  <input [formControl]="data.control" class="form-row__input" nz-input placeholder="Nhập">
                </nz-form-control>
              </nz-form-item>
            </td>
            <td>
              <app-job-select [list-input]="allFruits" [list-select]="data.jobDTOS" (eventAdd)="updateJob($event)">
              </app-job-select>
            </td>
            <td>
              <div class="init-model-template-card__table--action" >
                <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu">
                  <mat-icon class="init-model-template-card__table--action__icon">more_vert</mat-icon>

                </button>

                <mat-menu #menu="matMenu">
                  <div mat-menu-item class="action-button" (click)="addOrg(data)">
                    <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                    <span nz-typography>Thêm đơn vị trực thuộc</span>
                  </div>
                  <div mat-menu-item class="action-button" (click)="addOrgLevel(listData,0)">
                    <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                    <span nz-typography>Thêm đơn vị ngang cấp</span>
                  </div>

                  <div mat-menu-item class="action-button" (click)="coppyOrg(listData, data, 0)">
                    <a><img alt="" src="../../../../../../../assets/images/icon/copy.svg"></a>
                    <span nz-typography>Sao chép</span>
                  </div>

                  <div mat-menu-item class="action-button" (click)="deleteOrg(listData, i, true)" *ngIf="listData?.length !== 1">
                    <a><img alt="" src="../../../../../../../assets/images/icon/delete.svg"></a>
                    <span nz-typography>Xóa</span>
                  </div>
                </mat-menu>
              </div>
            </td>
          </tr>

          <ng-container *ngFor="let dv1 of data.subs; let i1 = index">
            <tr>
              <td nzLeft></td>
              <td style="padding-left: 40px;">
                <nz-form-item>
                  <nz-form-control nzValidateStatus="" [nzErrorTip]="dv1.control.errors?.pattern ? valid : require">
                    <input [formControl]="dv1.control" class="form-row__input" nz-input placeholder="Nhập">
                  </nz-form-control>
                </nz-form-item>
              </td>
              <td>
                <app-job-select class="job-select" [list-input]="allFruits" [list-select]="dv1.jobDTOS" (eventAdd)="updateJob($event)">
                </app-job-select>
              </td>
              <td>
                <div class="init-model-template-card__table--action">
                  <button class="style-button__white" mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu">
                    <mat-icon class="init-model-template-card__table--action__icon">more_vert</mat-icon>
                  </button>

                  <mat-menu #menu="matMenu">
                    <div mat-menu-item class="action-button" (click)="addOrg(dv1)">
                      <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                      <span nz-typography>Thêm đơn vị trực thuộc</span>
                    </div>
                    <div mat-menu-item class="action-button" (click)="addOrgLevel(data.subs,1)">
                      <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                      <span nz-typography>Thêm đơn vị ngang cấp</span>
                    </div>

                    <div mat-menu-item class="action-button" (click)="coppyOrg(data.subs, dv1,1)">
                      <a><img alt="" src="../../../../../../../assets/images/icon/copy.svg"></a>
                      <span nz-typography>Sao chép</span>
                    </div>

                    <div mat-menu-item class="action-button" (click)="deleteOrg(data.subs, i1)">
                      <a><img alt="" src="../../../../../../../assets/images/icon/delete.svg"></a>
                      <span nz-typography>Xóa</span>
                    </div>
                  </mat-menu>
                </div>
              </td>
            </tr>

            <ng-container *ngFor="let dv2 of dv1.subs; let i2 = index">
              <tr>
                <td nzLeft></td>
                <td style="padding-left: 60px;">
                  <nz-form-item>
                    <nz-form-control nzValidateStatus="" [nzErrorTip]="dv2.control.errors?.pattern ? valid : require">
                      <input [formControl]="dv2.control" class="form-row__input" nz-input placeholder="Nhập">
                    </nz-form-control>
                  </nz-form-item>
                </td>

                <td>
                  <app-job-select [list-input]="allFruits" [list-select]="dv2.jobDTOS" (eventAdd)="updateJob($event)">
                  </app-job-select>
                </td>
                <td>
                  <div class="init-model-template-card__table--action">
                    <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu">
                      <mat-icon class="init-model-template-card__table--action__icon">more_vert
                      </mat-icon>
                    </button>

                    <mat-menu #menu="matMenu">
                      <div mat-menu-item class="action-button" (click)="addOrg(dv2)">
                        <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                        <span nz-typography>Thêm đơn vị trực thuộc</span>
                      </div>
                      <div mat-menu-item class="action-button" (click)="addOrgLevel(dv1.subs,2)">
                        <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                        <span nz-typography>Thêm đơn vị ngang cấp</span>
                      </div>

                      <div mat-menu-item class="action-button" (click)="coppyOrg(dv1.subs, dv2,2)">
                        <a><img alt="" src="../../../../../../../assets/images/icon/copy.svg"></a>
                        <span nz-typography>Sao chép</span>
                      </div>

                      <div mat-menu-item class="action-button" (click)="deleteOrg(dv1.subs, i2)">
                        <a><img alt="" src="../../../../../../../assets/images/icon/delete.svg"></a>
                        <span nz-typography>Xóa</span>
                      </div>
                    </mat-menu>
                  </div>
                </td>
              </tr>


              <ng-container *ngFor="let dv3 of dv2.subs; let i3 = index">
                <tr>
                  <td nzLeft></td>
                  <td style="padding-left: 80px;">
                    <nz-form-item>
                      <nz-form-control nzValidateStatus="" [nzErrorTip]="dv3.control.errors?.pattern ? valid : require">
                        <input [formControl]="dv3.control" class="form-row__input" nz-input placeholder="Nhập">
                      </nz-form-control>
                    </nz-form-item>
                  </td>

                  <td>
                    <app-job-select [list-input]="allFruits" [list-select]="dv3.jobDTOS" (eventAdd)="updateJob($event)">
                    </app-job-select>
                  </td>
                  <td>
                    <div class="init-model-template-card__table--action">
                      <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu">
                        <mat-icon class="init-model-template-card__table--action__icon">more_vert
                        </mat-icon>

                      </button>

                      <mat-menu #menu="matMenu">
                        <div mat-menu-item class="action-button" (click)="addOrgLevel(dv2.subs,3)">
                          <a><img alt="" src="../../../../../../../assets/images/icon/plus.svg"> </a>
                          <span nz-typography>Thêm đơn vị ngang cấp</span>
                        </div>

                        <div mat-menu-item class="action-button" (click)="coppyOrg(dv2.subs, dv3,3)">
                          <a><img alt="" src="../../../../../../../assets/images/icon/copy.svg"></a>
                          <span nz-typography>Sao chép</span>
                        </div>

                        <div mat-menu-item class="action-button" (click)="deleteOrg(dv2.subs, i3)">
                          <a><img alt="" src="../../../../../../../assets/images/icon/delete.svg"></a>
                          <span nz-typography>Xóa</span>
                        </div>
                      </mat-menu>
                    </div>
                  </td>
                </tr>
              </ng-container>
            </ng-container>
          </ng-container>
        </ng-container>
      </tbody>
    </nz-table>
  </div>
</form>
